- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Static Public Member Functions | List of all members
pdftron::PDF::Annots::Sound Class Reference

`#include <Sound.h>`

Inheritance diagram for pdftron::PDF::Annots::Sound:

## Public Types
enum | Icon { e_Speaker, e_Mic, e_Unknown }
Public Types inherited from pdftron::PDF::Annots::Markup
enum | BorderEffect { e_None, e_Cloudy }
Public Types inherited from pdftron::PDF::Annot
enum | Type { e_Text, e_Link, e_FreeText, e_Line, e_Square, e_Circle, e_Polygon, e_Polyline, e_Highlight, e_Underline, e_Squiggly, e_StrikeOut, e_Stamp, e_Caret, e_Ink, e_Popup, e_FileAttachment, e_Sound, e_Movie, e_Widget, e_Screen, e_PrinterMark, e_TrapNet, e_Watermark, e_3D, e_Redact, e_Projection, e_RichMedia, e_Unknown }
enum | Flag { e_invisible, e_hidden, e_print, e_no_zoom, e_no_rotate, e_no_view, e_read_only, e_locked, e_toggle_no_view, e_locked_contents }
enum | ActionTriggerEvent { e_action_trigger_activate = 0, e_action_trigger_annot_enter = 1, e_action_trigger_annot_exit = 2, e_action_trigger_annot_down = 3, e_action_trigger_annot_up = 4, e_action_trigger_annot_focus = 5, e_action_trigger_annot_blur = 6, e_action_trigger_annot_page_open = 7, e_action_trigger_annot_page_close = 8, e_action_trigger_annot_page_visible = 9, e_action_trigger_annot_page_invisible = 10 }
enum | AnnotationState { e_normal, e_rollover, e_down }
typedef pdftron::PDF::BorderStyle | BorderStyle

## Public Member Functions
| Sound (SDF::Obj d=0)
| Sound (const Annot &ann)
SDF::Obj | GetSoundStream () const
void | SetSoundStream (SDF::Obj icon)
Icon | GetIcon () const
void | SetIcon (Icon type=e_Speaker)
const char * | GetIconName () const
void | SetIcon (const char *type)
Public Member Functions inherited from pdftron::PDF::Annots::Markup
| Markup (SDF::Obj d=0)
| Markup (const Annot &ann)
UString | GetTitle ()
void | SetTitle (const UString &title)
void | SetTitle (const char *title)
Popup | GetPopup () const
void | SetPopup (const Popup &ppup)
double | GetOpacity () const
void | SetOpacity (double op)
UString | GetSubject () const
void | SetSubject (const UString &contents)
Date | GetCreationDates () const
void | SetCreationDates (const Date &dt)
BorderEffect | GetBorderEffect () const
void | SetBorderEffect (BorderEffect effect=e_None)
double | GetBorderEffectIntensity () const
void | SetBorderEffectIntensity (double intensity=0)
ColorPt | GetInteriorColor () const
int | GetInteriorColorCompNum () const
void | SetInteriorColor (const ColorPt &c, int CompNum)
Rect | GetContentRect () const
void | SetContentRect (const Rect &cr)
Rect | GetPadding () const
void | SetPadding (const Rect &rd)
void | SetPadding (double x)
void | RotateAppearance (double angle)
Public Member Functions inherited from pdftron::PDF::Annot
| Annot (SDF::Obj d=0)
| Annot (const Annot &d)
Annot & | operator= (const Annot &d)
bool | operator== (const Annot &d)
bool | IsValid () const
SDF::Obj | GetSDFObj () const
Type | GetType () const
Rect | GetRect () const
Rect | GetVisibleContentBox () const
bool | IsMarkup () const
void | SetRect (const Rect &pos)
Page | GetPage () const
void | SetPage (const Page &page)
SDF::Obj | GetUniqueID () const
void | SetUniqueID (const char *id, int id_buf_sz=0)
Date | GetDate () const
void | SetDate (const Date &date)
bool | GetFlag (Flag flag) const
void | SetFlag (Flag flag, bool value)
SDF::Obj | GetTriggerAction (Annot::ActionTriggerEvent trigger)
BorderStyle | GetBorderStyle () const
void | SetBorderStyle (const BorderStyle &bs, bool oldStyleOnly=false)
SDF::Obj | GetAppearance (AnnotationState annot_state=e_normal, const char *app_state=0)
void | SetAppearance (SDF::Obj app_stream, AnnotationState annot_state=e_normal, const char *app_state=0)
void | RemoveAppearance (AnnotationState annot_state=e_normal, const char *app_state=0)
void | Flatten (class Page page)
const char * | GetActiveAppearanceState () const
void | SetActiveAppearanceState (const char *astate)
ColorPt | GetColorAsRGB () const
ColorPt | GetColorAsCMYK () const
ColorPt | GetColorAsGray () const
int | GetColorCompNum () const
void | SetColor (const ColorPt &col, int numcomp=3)
int | GetStructParent () const
void | SetStructParent (const int parkeyval)
SDF::Obj | GetOptionalContent () const
void | SetOptionalContent (SDF::Obj content)
void | SetContents (const UString &contents)
UString | GetContents () const
int | GetRotation () const
void | SetRotation (int angle)
void | RefreshAppearance ()
void | RefreshAppearance (const RefreshOptions &options)
UString | GetCustomData (const UString &key) const
void | SetCustomData (const UString &key, const UString &value)
void | DeleteCustomData (const UString &key)
void | Resize (const Rect &newrect)
ptrdiff_t | GetHandleInternal ()

## Static Public Member Functions
static Sound | Create (SDF::SDFDoc &doc, const Rect &pos, Icon icon=e_Speaker)
static Sound | CreateAnnot (SDF::SDFDoc &doc, const Rect &pos, Icon icon=e_Speaker)
static Sound | CreateWithData (SDF::SDFDoc &doc, const Rect &pos, Filters::Filter source_data, int bits_per_sample, int sample_freq, int num_channels, Icon icon=e_Speaker)
static Sound | Create (SDF::SDFDoc &doc, const Point &pos, Icon icon=e_Speaker)
static Sound | CreateAnnot (SDF::SDFDoc &doc, const Point &pos, Icon icon=e_Speaker)
Static Public Member Functions inherited from pdftron::PDF::Annot
static Annot | Create (SDF::SDFDoc &doc, Type type, const Rect &pos)
static Annot * | CreateInternal (ptrdiff_t impl)

## Detailed Description

A Sound annotation represents a sound recording attached to a point in the PDF document. When closed, this annotation appear as an icon; when open and activated, a sound record from the computer's microphone or imported from a file associated with this annotation is played.The icon of this annotation by default is a speaker.

Definition at line 20 of file Sound.h.

## Member Enumeration Documentation

enum pdftron::PDF::Annots::Sound::Icon

The Icon of the Sound annotation.

Enumerator
e_Speaker | Speaker sound.
e_Mic | Mic sound.
e_Unknown | Invalid or non-standard.

Definition at line 26 of file Sound.h.

## Constructor & Destructor Documentation

pdftron::PDF::Annots::Sound::Sound | ( | SDF::Obj | d = `0` | ) |

Creates a Sound annotation and initializes it using given Cos/SDF object.

Parameters

  d | The Cos/SDF object to initialze the annotation with.

Note
  The constructor does not copy any data, but is instead the logical equivalent of a type cast.

pdftron::PDF::Annots::Sound::Sound | ( | const Annot & | ann | ) |
| inline

Creates a Sound annotation and initializes it using given annotation object.

Parameters

  ann | Annot object used to initialize the Sound annotation.

Note
  The constructor does not copy any data, but is instead the logical equivalent of a type cast.

Definition at line 47 of file Sound.h.

## Member Function Documentation

static Sound pdftron::PDF::Annots::Sound::Create | ( | SDF::SDFDoc & | doc,
|  | const Rect & | pos,
|  | Icon | icon = `e_Speaker`
| ) |  |
| static

Creates a new Sound annotation in the specified document.

Parameters

  doc | A document to which the annotation is added.
  pos | A rectangle specifying the annotation's bounds in default user space units.

Returns
  A newly created blank Sound annotation.

static Sound pdftron::PDF::Annots::Sound::Create | ( | SDF::SDFDoc & | doc,
|  | const Point & | pos,
|  | Icon | icon = `e_Speaker`
| ) |  |
| static

Creates a new Sound annotation in the specified document.

Parameters

  doc | A document to which the annotation is added.
  pos | A point specifying the annotation's location in default user space units.

Returns
  A newly created blank Sound annotation.

static Sound pdftron::PDF::Annots::Sound::CreateAnnot | ( | SDF::SDFDoc & | doc,
|  | const Rect & | pos,
|  | Icon | icon = `e_Speaker`
| ) |  |
| static

static Sound pdftron::PDF::Annots::Sound::CreateAnnot | ( | SDF::SDFDoc & | doc,
|  | const Point & | pos,
|  | Icon | icon = `e_Speaker`
| ) |  |
| static

static Sound pdftron::PDF::Annots::Sound::CreateWithData | ( | SDF::SDFDoc & | doc,
|  | const Rect & | pos,
|  | Filters::Filter | source_data,
|  | int | bits_per_sample,
|  | int | sample_freq,
|  | int | num_channels,
|  | Icon | icon = `e_Speaker`
| ) |  |
| static

Creates a new Sound annotation in the specified document. Accepts raw audio data, along with a few parameters describing the format of that data

Parameters

  doc | A document to which the annotation is added.
  pos | A rectangle specifying the annotation's bounds in default user space units.
  source_data | The raw sound data for the newly created annot
  bits_per_sample | The number of bits per sample in source data
  sample_freq | The number of samples per second present in source data
  num_channels | The number of audio channels in source_data
  icon | A value of the "Icon" enumeration type specifying the icon to display.

Returns
  A newly created blank Sound annotation.

Icon pdftron::PDF::Annots::Sound::GetIcon | ( |  | ) | const

Returns the Icon of the Sound annotation.

Returns
  A value of the "Icon" enum. Default value: e_Speaker.

Note
  The Icon defines the appearance associated with the Sound annotation. The annotation's appearance stream, if present, will take precedence over this entry.

const char* pdftron::PDF::Annots::Sound::GetIconName | ( |  | ) | const

Returns the Icon name of the Sound annotation.

Returns
  A string denoting the Icon name of the Sound annotation.

Note
  The following Icon names are equivalent to predefined Icons from the enum "Icon": "Speaker" = e_Speaker "Mic" = e_Mic "Unknown" = e_Unknown The Icon defines the appearance associated with the Sound annotation. Names other than mentioned above do not have predefined icon appearances. The annotation's appearance stream, if present, will take precedence over this entry.

SDF::Obj pdftron::PDF::Annots::Sound::GetSoundStream | ( |  | ) | const

Returns the sound object of the Sound annotation.

Returns
  An SDF object representing a sound stream.

Note
  The sound stream is to be played when the Sound annotation is activated.

void pdftron::PDF::Annots::Sound::SetIcon | ( | Icon | type = `e_Speaker` | ) |

Sets the Icon of the Sound annotation. (Optional)

Parameters

  type | A value of the "Icon" enumeration type specifying the icon to display. Default value: e_Speaker.

Note
  The Icon defines the appearance associated with the Sound annotation. The annotation's appearance stream, if present, will take precedence over this entry.

void pdftron::PDF::Annots::Sound::SetIcon | ( | const char * | type | ) |

Sets the Icon name of the Sound annotation. (Optional)

Parameters

  type | A string denoting the Icon name of the Sound annotation.

Note
  The following Icon names are equivalent to predefined types from the enum "Icon": "Speaker" = e_Speaker "Mic" = e_Mic "Unknown" = e_Unknown The Icon defines the appearance associated with the Sound annotation. Names other than mentioned above do not have predefined icon appearances. The annotation's appearance stream, if present, will take precedence over this entry.

void pdftron::PDF::Annots::Sound::SetSoundStream | ( | SDF::Obj | icon | ) |

Sets the sound object of the Sound annotation.

Parameters

  icon | An SDF object representing a sound stream.

Note
  The sound stream is to be played when the Sound annotation is activated.

The documentation for this class was generated from the following file:

- PDF/Annots/Sound.h